"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _asn1js = require("asn1js");

var asn1js = _interopRequireWildcard(_asn1js);

var _pvutils = require("pvutils");

var _pkijs = require("pkijs");

var _ATSHashIndex = require("./ATSHashIndex.js");

var _ATSHashIndex2 = _interopRequireDefault(_ATSHashIndex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//**************************************************************************************
// noinspection JSUnusedGlobalSymbols
var ArchiveTimeStampV3 = function (_ContentInfo) {
	_inherits(ArchiveTimeStampV3, _ContentInfo);

	//**********************************************************************************
	/**
  * Constructor for ArchiveTimeStampV3 class
  * @param {Object} [parameters={}]
  * @property {Object} [schema] asn1js parsed value
  */
	function ArchiveTimeStampV3() {
		var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		_classCallCheck(this, ArchiveTimeStampV3);

		//region Internal properties of the object
		var _this = _possibleConstructorReturn(this, (ArchiveTimeStampV3.__proto__ || Object.getPrototypeOf(ArchiveTimeStampV3)).call(this, parameters));

		if ("tspResponse" in parameters)
			/**
    * @type {ArrayBuffer}
    * @description tspResponse
    */
			_this.tspResponse = (0, _pvutils.getParametersValue)(parameters, "tspResponse", ArchiveTimeStampV3.defaultValues("tspResponse"));

		/**
   * @type {ATSHashIndex}
   * @description aTSHashIndex
   */
		_this.aTSHashIndex = (0, _pvutils.getParametersValue)(parameters, "aTSHashIndex", ArchiveTimeStampV3.defaultValues("aTSHashIndex"));
		//endregion

		//region If input argument array contains "schema" for this object
		if ("schema" in parameters) _this.fromSchema(parameters.schema);
		//endregion
		return _this;
	}
	//**********************************************************************************
	/**
  * Return default values for all class members
  * @param {string} memberName String name for a class member
  */


	_createClass(ArchiveTimeStampV3, [{
		key: "fromSchema",

		//**********************************************************************************
		/**
   * Convert parsed asn1js object into current class
   * @param {!Object} schema
   * @param {boolean} [initValues=true]
   */
		value: function fromSchema(schema) {
			var initValues = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

			_get(ArchiveTimeStampV3.prototype.__proto__ || Object.getPrototypeOf(ArchiveTimeStampV3.prototype), "fromSchema", this).call(this, schema);

			if (initValues) {
				if (this.contentType !== "1.2.840.113549.1.7.2") throw new Error("Incorrect object schema for archive-time-stamp-v3 attribute: incorrect content type");

				this.tspResponse = new _pkijs.TimeStampResp({ timeStampToken: schema });

				var cmsSignedData = new _pkijs.SignedData({ schema: this.content });

				if (cmsSignedData.signerInfos.length !== 1) throw new Error("Incorrect object schema for archive-time-stamp-v3 attribute: incorrect signerInfos length");

				if ("unsignedAttrs" in cmsSignedData.signerInfos[0] === false) throw new Error("Incorrect object schema for archive-time-stamp-v3 attribute: missing unsignedAttrs");

				if (cmsSignedData.signerInfos[0].unsignedAttrs.attributes.length !== 1) throw new Error("Incorrect object schema for archive-time-stamp-v3 attribute: incorrect unsignedAttrs length");

				var attribute = new _pkijs.Attribute(cmsSignedData.signerInfos[0].unsignedAttrs.attributes[0]);

				if (attribute.type !== "0.4.0.1733.2.5") throw new Error("Incorrect object schema for archive-time-stamp-v3 attribute: incorrect type for aTSHashIndex value");

				var parsedValue = void 0;

				try {
					parsedValue = new _ATSHashIndex2.default({ schema: attribute.values[0] });
				} catch (e) {
					throw new Error("Incorrect object schema for archive-time-stamp-v3 attribute: incorrect aTSHashIndex value");
				}

				this.aTSHashIndex = parsedValue;
			}
		}
		//**********************************************************************************
		// noinspection JSUnusedGlobalSymbols
		/**
   * Get "ArrayBuffer" to transfer to time-stamp server
   * @param {SignedData} cmsSignedData CMS Signed Data to make attribute for
   * @param {number} signerIndex Index of signer to make attribute for
   * @param {Object} parameters Additional parameters for making attribute
   * @returns {Promise}
   */

	}, {
		key: "getStampingBuffer",
		value: function getStampingBuffer(cmsSignedData, signerIndex, parameters) {
			//region Initial variables
			var sequence = Promise.resolve();

			var hashAlgorithm = "SHA-256";

			var content = new ArrayBuffer(0);
			var aTSHashIndex = new ArrayBuffer(0);

			var resultBuffer = new ArrayBuffer(0);
			//endregion

			//region Get a "crypto" extension
			var crypto = (0, _pkijs.getCrypto)();
			if (typeof crypto === "undefined") return Promise.reject("Unable to create WebCrypto object");
			//endregion

			//region Check input parameters
			if ("hashAlgorithm" in parameters) hashAlgorithm = parameters.hashAlgorithm;

			if ("content" in parameters) content = parameters.content; // ArrayBuffer
			else {
					if ("eContent" in cmsSignedData.encapContentInfo) {
						if (cmsSignedData.encapContentInfo.eContent.idBlock.tagClass === 1 && cmsSignedData.encapContentInfo.eContent.idBlock.tagNumber === 4) {
							if (cmsSignedData.encapContentInfo.eContent.idBlock.isConstructed === false) content = cmsSignedData.encapContentInfo.eContent.valueBlock.valueHex;else {
								for (var i = 0; i < cmsSignedData.encapContentInfo.eContent.valueBlock.value.length; i++) {
									content = (0, _pvutils.utilConcatBuf)(content, cmsSignedData.encapContentInfo.eContent.valueBlock.value[i].valueBlock.valueHex);
								}
							}
						} else content = cmsSignedData.encapContentInfo.eContent.valueBlock.valueHex;
					} else return Promise.reject("Parameter \"content\" is mandatory for making archive-time-stamp-v3");
				}

			if ("aTSHashIndex" in parameters) aTSHashIndex = parameters.aTSHashIndex; // ArrayBuffer
			else return Promise.reject("Parameter \"aTSHashIndex\" is mandatory for making archive-time-stamp-v3");
			//endregion

			//region Make hash of initial content
			sequence = sequence.then(function () {
				return crypto.digest({ name: hashAlgorithm }, content);
			}, function (error) {
				return Promise.reject(error);
			});
			//endregion

			//region Make final stamping buffer
			sequence = sequence.then(function (result) {
				//region eContentType
				var contentOID = new asn1js.ObjectIdentifier({ value: cmsSignedData.encapContentInfo.eContentType });
				resultBuffer = (0, _pvutils.utilConcatBuf)(resultBuffer, contentOID.toBER(false));
				//endregion

				//region message-digest
				// noinspection JSCheckFunctionSignatures
				resultBuffer = (0, _pvutils.utilConcatBuf)(resultBuffer, result);
				//endregion

				//region version
				var version = new asn1js.Integer({ value: cmsSignedData.signerInfos[signerIndex].version });
				resultBuffer = (0, _pvutils.utilConcatBuf)(resultBuffer, version.toBER(false));
				//endregion

				//region sid
				var sid = void 0;

				if (cmsSignedData.signerInfos[signerIndex].sid instanceof _pkijs.IssuerAndSerialNumber) sid = cmsSignedData.signerInfos[signerIndex].sid.toSchema();else sid = cmsSignedData.signerInfos[signerIndex].sid;

				resultBuffer = (0, _pvutils.utilConcatBuf)(resultBuffer, sid.toBER(false));
				//endregion

				//region digestAlgorithm
				resultBuffer = (0, _pvutils.utilConcatBuf)(resultBuffer, cmsSignedData.signerInfos[signerIndex].digestAlgorithm.toSchema().toBER(false));
				//endregion

				//region signedAttrs
				if ("signedAttrs" in cmsSignedData.signerInfos[signerIndex]) resultBuffer = (0, _pvutils.utilConcatBuf)(resultBuffer, cmsSignedData.signerInfos[signerIndex].signedAttrs.toSchema().toBER(false));else return Promise.reject("Must be \"signedAttrs\" inside SignerInfo structure. Check correctness of the signed data.");
				//endregion

				//region signatureAlgorithm
				resultBuffer = (0, _pvutils.utilConcatBuf)(resultBuffer, cmsSignedData.signerInfos[signerIndex].signatureAlgorithm.toSchema().toBER(false));
				//endregion

				//region signature
				resultBuffer = (0, _pvutils.utilConcatBuf)(resultBuffer, cmsSignedData.signerInfos[signerIndex].signature.toBER(false));
				//endregion

				//region ATSHashIndexV2
				resultBuffer = (0, _pvutils.utilConcatBuf)(resultBuffer, aTSHashIndex);
				//endregion

				return resultBuffer;
			}, function (error) {
				return Promise.reject(error);
			});
			//endregion

			//region Make hash of result buffer
			sequence = sequence.then(function (result) {
				return crypto.digest({ name: hashAlgorithm }, result);
			}, function (error) {
				return Promise.reject(error);
			});
			//endregion

			return sequence;
		}
		//**********************************************************************************
		/**
   * Create "archive-time-stamp-v3" CAdES attribute
   * @param {Object} [parameters] Additional parameters for making attribute
   * @returns {Attribute}
   */

	}, {
		key: "makeAttribute",
		value: function makeAttribute() {
			var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			//region Initial variables
			var tspResponse = void 0;
			//endregion

			//region Check input parameters
			if ("tspResponse" in parameters) tspResponse = parameters.tspResponse;else {
				if ("tspResponse" in this) tspResponse = this.tspResponse;else throw new Error("Parameter \"tspResponse\" is mandatory for making archive-time-stamp-v3 attribute");
			}

			this.tspResponse = tspResponse;
			//endregion

			//region Change type of "tspResponse"
			var asn1 = asn1js.fromBER(tspResponse);
			tspResponse = new _pkijs.TimeStampResp({ schema: asn1.result });
			//endregion

			//region Initialize internal variables from "tspResponse"
			if ("timeStampToken" in tspResponse) this.fromSchema(tspResponse.timeStampToken.toSchema(), false);else throw new Error("No neccessary \"timeStampToken\" inside \"tspResponse\"");
			//endregion

			//region Append "ATSHashIndex" into local unsigned attributes
			var cmsSignedData = new _pkijs.SignedData({ schema: this.content });

			cmsSignedData.signerInfos[0].unsignedAttrs = new _pkijs.SignedAndUnsignedAttributes({
				type: 1, // UnsignedAttributes
				attributes: [this.aTSHashIndex.makeAttribute()]
			});

			this.content = cmsSignedData.toSchema();
			//endregion

			//region Create and return attribute
			return new _pkijs.Attribute({
				type: "0.4.0.1733.2.4",
				values: [this.toSchema()]
			});
			//endregion
		}
		//**********************************************************************************

	}], [{
		key: "defaultValues",
		value: function defaultValues(memberName) {
			switch (memberName) {
				case "tspResponse":
					return new ArrayBuffer(0);
				case "aTSHashIndex":
					return new _ATSHashIndex2.default();
				default:
					throw new Error("Invalid member name for ArchiveTimeStampV3 class: " + memberName);
			}
		}
		//**********************************************************************************
		/**
   * Compare values with default values for all class members
   * @param {string} memberName String name for a class member
   * @param {*} memberValue Value to compare with default value
   */

	}, {
		key: "compareWithDefault",
		value: function compareWithDefault(memberName, memberValue) {
			switch (memberName) {
				case "tspResponse":
					return memberValue.byteLength === 0;
				case "aTSHashIndex":
					// noinspection OverlyComplexBooleanExpressionJS
					return "hashIndAlgorithm" in memberValue === false && _ATSHashIndex2.default.compareWithDefault("certificatesHashIndex", memberValue.certificatesHashIndex) && _ATSHashIndex2.default.compareWithDefault("crlsHashIndex", memberValue.crlsHashIndex) && _ATSHashIndex2.default.compareWithDefault("unsignedAttrsHashIndex", memberValue.unsignedAttrsHashIndex);
				default:
					throw new Error("Invalid member name for ArchiveTimeStampV3 class: " + memberName);
			}
		}
	}]);

	return ArchiveTimeStampV3;
}(_pkijs.ContentInfo);
//**************************************************************************************


exports.default = ArchiveTimeStampV3;
//# sourceMappingURL=ArchiveTimeStampV3.js.map