"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _pkijs = require("pkijs");

var _ATSHashIndex = require("./ATSHashIndex.js");

var _ATSHashIndex2 = _interopRequireDefault(_ATSHashIndex);

var _ArchiveTimeStampV = require("./ArchiveTimeStampV3.js");

var _ArchiveTimeStampV2 = _interopRequireDefault(_ArchiveTimeStampV);

var _SignatureTimeStamp = require("./SignatureTimeStamp.js");

var _SignatureTimeStamp2 = _interopRequireDefault(_SignatureTimeStamp);

var _CompleteCertificateReferences = require("./CompleteCertificateReferences.js");

var _CompleteCertificateReferences2 = _interopRequireDefault(_CompleteCertificateReferences);

var _CompleteRevocationReferences = require("./CompleteRevocationReferences.js");

var _CompleteRevocationReferences2 = _interopRequireDefault(_CompleteRevocationReferences);

var _CAdESCTimestamp = require("./CAdESCTimestamp.js");

var _CAdESCTimestamp2 = _interopRequireDefault(_CAdESCTimestamp);

var _CertificateValues = require("./CertificateValues.js");

var _CertificateValues2 = _interopRequireDefault(_CertificateValues);

var _RevocationValues = require("./RevocationValues.js");

var _RevocationValues2 = _interopRequireDefault(_RevocationValues);

var _RevocationInfoArchival = require("./RevocationInfoArchival.js");

var _RevocationInfoArchival2 = _interopRequireDefault(_RevocationInfoArchival);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//**************************************************************************************
var AttributeCAdES = function (_Attribute) {
	_inherits(AttributeCAdES, _Attribute);

	//**********************************************************************************
	/**
  * Constructor for SignedAndUnsignedAttributesCAdES class
  * @param {Object} [parameters={}]
  * @property {Object} [schema] asn1js parsed value
  */
	function AttributeCAdES(parameters) {
		_classCallCheck(this, AttributeCAdES);

		var _this = _possibleConstructorReturn(this, (AttributeCAdES.__proto__ || Object.getPrototypeOf(AttributeCAdES)).call(this, parameters));

		_this.initializeParsedValues();
		return _this;
	}
	//**********************************************************************************
	/**
  * Convert parsed asn1js object into current class
  * @param {!Object} schema
  */


	_createClass(AttributeCAdES, [{
		key: "fromSchema",
		value: function fromSchema(schema) {
			_get(AttributeCAdES.prototype.__proto__ || Object.getPrototypeOf(AttributeCAdES.prototype), "fromSchema", this).call(this, schema);

			this.initializeParsedValues();
		}
		//**********************************************************************************

	}, {
		key: "initializeParsedValues",
		value: function initializeParsedValues() {
			switch (this.type) {
				case "0.4.0.1733.2.5":
					// ATSHashIndex
					this.parsedValue = new _ATSHashIndex2.default({ schema: this.values[0] });
					break;
				case "0.4.0.1733.2.4":
					// archive-time-stamp-v3
					this.parsedValue = new _ArchiveTimeStampV2.default({ schema: this.values[0] });
					break;
				case "1.2.840.113549.1.9.16.2.14":
					// signature-time-stamp
					this.parsedValue = new _SignatureTimeStamp2.default({ schema: this.values[0] });
					break;
				case "1.2.840.113549.1.9.16.2.21":
					// complete-certificate-references
					this.parsedValue = new _CompleteCertificateReferences2.default({ schema: this.values[0] });
					break;
				case "1.2.840.113549.1.9.16.2.22":
					// complete-revocation-references
					this.parsedValue = new _CompleteRevocationReferences2.default({ schema: this.values[0] });
					break;
				case "1.2.840.113549.1.9.16.2.25":
					// CAdES-C-Timestamp
					this.parsedValue = new _CAdESCTimestamp2.default({ schema: this.values[0] });
					break;
				case "1.2.840.113549.1.9.16.2.23":
					// certificate-values
					this.parsedValue = new _CertificateValues2.default({ schema: this.values[0] });
					break;
				case "1.2.840.113549.1.9.16.2.24":
					// revocation-values
					this.parsedValue = new _RevocationValues2.default({ schema: this.values[0] });
					break;
				case "1.2.840.113583.1.1.8":
					// Adobe "RevocationInfoArchival"
					this.parsedValue = new _RevocationInfoArchival2.default({ schema: this.values[0] });
					break;
				default:
			}
		}
		//**********************************************************************************

	}]);

	return AttributeCAdES;
}(_pkijs.Attribute);
//**************************************************************************************


exports.default = AttributeCAdES;
//# sourceMappingURL=AttributeCAdES.js.map