"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _asn1js = require("asn1js");

var asn1js = _interopRequireWildcard(_asn1js);

var _pvutils = require("pvutils");

var _CommitmentTypeQualifier = require("./CommitmentTypeQualifier.js");

var _CommitmentTypeQualifier2 = _interopRequireDefault(_CommitmentTypeQualifier);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

//**************************************************************************************
// noinspection JSUnusedGlobalSymbols
var CommitmentTypeIndication = function () {
	//**********************************************************************************
	/**
  * Constructor for CommitmentTypeIndication class
  * @param {Object} [parameters={}]
  * @property {Object} [schema] asn1js parsed value
  */
	function CommitmentTypeIndication() {
		var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		_classCallCheck(this, CommitmentTypeIndication);

		//region Internal properties of the object
		/**
   * @type {string}
   * @description commitmentTypeId
   */
		this.commitmentTypeId = (0, _pvutils.getParametersValue)(parameters, "commitmentTypeId", CommitmentTypeIndication.defaultValues("commitmentTypeId"));

		if ("commitmentTypeQualifier" in parameters)
			/**
    * @type {Array.<CommitmentTypeQualifier>}
    * @description commitmentTypeQualifier
    */
			this.commitmentTypeQualifier = (0, _pvutils.getParametersValue)(parameters, "commitmentTypeQualifier", CommitmentTypeIndication.defaultValues("commitmentTypeQualifier"));
		//endregion

		//region If input argument array contains "schema" for this object
		if ("schema" in parameters) this.fromSchema(parameters.schema);
		//endregion
	}
	//**********************************************************************************
	/**
  * Return default values for all class members
  * @param {string} memberName String name for a class member
  */


	_createClass(CommitmentTypeIndication, [{
		key: "fromSchema",

		//**********************************************************************************
		/**
   * Convert parsed asn1js object into current class
   * @param {!Object} schema
   */
		value: function fromSchema(schema) {
			//region Check the schema is valid
			var asn1 = asn1js.compareSchema(schema, schema, CommitmentTypeIndication.schema({
				names: {
					commitmentTypeId: "commitmentTypeId",
					commitmentTypeQualifier: "commitmentTypeQualifier"
				}
			}));

			if (asn1.verified === false) throw new Error("Object's schema was not verified against input data for CommitmentTypeIndication");
			//endregion

			//region Get internal properties from parsed schema
			this.commitmentTypeId = asn1.result.commitmentTypeId.valueBlock.toString();

			if ("commitmentTypeQualifier" in asn1.result) this.commitmentTypeQualifier = Array.from(asn1.result.commitmentTypeQualifier, function (element) {
				return new _CommitmentTypeQualifier2.default({ schema: element });
			});
			//endregion
		}
		//**********************************************************************************
		/**
   * Convert current object to asn1js object and set correct values
   * @returns {Object} asn1js object
   */

	}, {
		key: "toSchema",
		value: function toSchema() {
			//region Create array for output sequence
			var outputArray = [new asn1js.ObjectIdentifier({ value: this.commitmentTypeId })];

			if ("commitmentTypeQualifier" in this) {
				outputArray.push(new asn1js.Sequence({
					value: Array.from(this.commitmentTypeQualifier, function (element) {
						return element.toSchema();
					})
				}));
			}
			//endregion

			//region Construct and return new ASN.1 schema for this object
			return new asn1js.Sequence({
				value: outputArray
			});
			//endregion
		}
		//**********************************************************************************
		/**
   * Convertion for the class to JSON object
   * @returns {Object}
   */

	}, {
		key: "toJSON",
		value: function toJSON() {
			var _object = {
				commitmentTypeId: this.commitmentTypeId
			};

			if ("commitmentTypeQualifier" in this) _object.commitmentTypeQualifier = Array.from(this.commitmentTypeQualifier, function (element) {
				return element.toJSON();
			});

			return _object;
		}
		//**********************************************************************************

	}], [{
		key: "defaultValues",
		value: function defaultValues(memberName) {
			switch (memberName) {
				case "commitmentTypeId":
					return "";
				case "commitmentTypeQualifier":
					return [];
				default:
					throw new Error("Invalid member name for CommitmentTypeIndication class: " + memberName);
			}
		}
		//**********************************************************************************
		/**
   * Compare values with default values for all class members
   * @param {string} memberName String name for a class member
   * @param {*} memberValue Value to compare with default value
   */

	}, {
		key: "compareWithDefault",
		value: function compareWithDefault(memberName, memberValue) {
			switch (memberName) {
				case "commitmentTypeId":
					return memberValue === "";
				case "commitmentTypeQualifier":
					return memberValue.length === 0;
				default:
					throw new Error("Invalid member name for CommitmentTypeIndication class: " + memberName);
			}
		}
		//**********************************************************************************
		/**
   * Return value of asn1js schema for current class
   * @param {Object} parameters Input parameters for the schema
   * @returns {Object} asn1js schema object
   */

	}, {
		key: "schema",
		value: function schema() {
			var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			// CommitmentTypeIdentifier ::= OBJECT IDENTIFIER
			//
			// CommitmentTypeIndication ::= SEQUENCE {
			//    commitmentTypeId CommitmentTypeIdentifier,
			//    commitmentTypeQualifier SEQUENCE SIZE (1..MAX) OF CommitmentTypeQualifier OPTIONAL}

			/**
    * @type {Object}
    * @property {string} [blockName]
    * @property {string} [commitmentTypeId]
    * @property {string} [commitmentTypeQualifier]
    */
			var names = (0, _pvutils.getParametersValue)(parameters, "names", {});

			return new asn1js.Sequence({
				name: names.blockName || "",
				value: [new asn1js.ObjectIdentifier({ name: names.commitmentTypeId || "" }), new asn1js.Sequence({
					optional: true,
					value: [new asn1js.Repeated({
						name: names.commitmentTypeQualifier || "",
						value: _CommitmentTypeQualifier2.default.schema()
					})]
				})]
			});
		}
	}]);

	return CommitmentTypeIndication;
}();
//**************************************************************************************


exports.default = CommitmentTypeIndication;
//# sourceMappingURL=CommitmentTypeIndication.js.map