"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _pkijs = require("pkijs");

var _CompleteCertificateRefs = require("./CompleteCertificateRefs.js");

var _CompleteCertificateRefs2 = _interopRequireDefault(_CompleteCertificateRefs);

var _OtherCertID = require("./OtherCertID.js");

var _OtherCertID2 = _interopRequireDefault(_OtherCertID);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//**************************************************************************************
// noinspection JSUnusedGlobalSymbols
var CompleteCertificateReferences = function (_CompleteCertificateR) {
	_inherits(CompleteCertificateReferences, _CompleteCertificateR);

	//**********************************************************************************
	/**
  * Constructor for CompleteCertificateReferences class
  * @param {Object} [parameters={}]
  * @property {Object} [schema] asn1js parsed value
  */
	function CompleteCertificateReferences() {
		var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		_classCallCheck(this, CompleteCertificateReferences);

		return _possibleConstructorReturn(this, (CompleteCertificateReferences.__proto__ || Object.getPrototypeOf(CompleteCertificateReferences)).call(this, parameters));
	}
	//**********************************************************************************
	/**
  * Creates "complete-certificate-references" for given CMS Signed Data and signer index
  * @param {SignedData} cmsSigned CMS Signed Data to make attribute for
  * @param {number} signerIndex Index of signer to make attribute for
  * @param {Object} parameters Additional parameters for making attribute
  * @returns {Promise}
  */


	_createClass(CompleteCertificateReferences, [{
		key: "fillValues",
		value: function fillValues(cmsSigned, signerIndex, parameters) {
			//region Initial variables
			var _this = this;

			var hashAlgorithm = "SHA-1";
			var signerCertificate = void 0; // in_window.org.pkijs.simpl.CERT
			//endregion

			//region Check input parameters
			if ("hashAlgorithm" in parameters) hashAlgorithm = parameters.hashAlgorithm;

			if ("signerCertificate" in parameters) signerCertificate = parameters.signerCertificate;else return Promise.reject("Parameter \"signerCertificate\" is mandatory for making \"complete-certificate-references\" attribute");
			//endregion

			//region Put all CMS Signed Data certificates inside "completeCertificateRefs" array
			if ("certificates" in cmsSigned) {
				var promises = [];

				for (var i = 0; i < cmsSigned.certificates.length; i++) {
					//region Check it is not a "signerCertificate"
					if (cmsSigned.certificates[i].issuer.isEqual(signerCertificate.issuer) && cmsSigned.certificates[i].serialNumber.isEqual(signerCertificate.serialNumber)) continue; // Not including "signer certificate" in "complete-certificate-references" attribute
					//endregion

					_this.completeCertificateRefs.push(new _OtherCertID2.default());
					promises.push(_this.completeCertificateRefs[_this.completeCertificateRefs.length - 1].fillValues({
						hashAlgorithm: hashAlgorithm,
						certificate: cmsSigned.certificates[i]
					}));
				}

				return Promise.all(promises);
			}
			//endregion

			return Promise.resolve();
		}
		//**********************************************************************************
		/**
   * Create "complete-certificate-references" CAdES attribute
   * @param {Object} [parameters]
   * @returns {Attribute}
   */

	}, {
		key: "makeAttribute",
		value: function makeAttribute() {
			var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			//region Create and return attribute
			return new _pkijs.Attribute({
				type: "1.2.840.113549.1.9.16.2.21",
				values: [this.toSchema()]
			});
			//endregion
		}
		//**********************************************************************************

	}]);

	return CompleteCertificateReferences;
}(_CompleteCertificateRefs2.default);
//**************************************************************************************


exports.default = CompleteCertificateReferences;
//# sourceMappingURL=CompleteCertificateReferences.js.map