"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _asn1js = require("asn1js");

var asn1js = _interopRequireWildcard(_asn1js);

var _pvutils = require("pvutils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

//**************************************************************************************
// noinspection JSUnusedGlobalSymbols
var ContentHints = function () {
	//**********************************************************************************
	/**
  * Constructor for ContentHints class
  * @param {Object} [parameters={}]
  * @property {Object} [schema] asn1js parsed value
  */
	function ContentHints() {
		var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		_classCallCheck(this, ContentHints);

		//region Internal properties of the object
		if ("contentDescription" in parameters)
			/**
    * @type {string}
    * @description contentDescription
    */
			this.contentDescription = (0, _pvutils.getParametersValue)(parameters, "contentDescription", ContentHints.defaultValues("contentDescription"));

		/**
   * @type {string}
   * @description contentType
   */
		this.contentType = (0, _pvutils.getParametersValue)(parameters, "contentType", ContentHints.defaultValues("contentType"));
		//endregion

		//region If input argument array contains "schema" for this object
		if ("schema" in parameters) this.fromSchema(parameters.schema);
		//endregion
	}
	//**********************************************************************************
	/**
  * Return default values for all class members
  * @param {string} memberName String name for a class member
  */


	_createClass(ContentHints, [{
		key: "fromSchema",

		//**********************************************************************************
		/**
   * Convert parsed asn1js object into current class
   * @param {!Object} schema
   */
		value: function fromSchema(schema) {
			//region Check the schema is valid
			var asn1 = asn1js.compareSchema(schema, schema, ContentHints.schema({
				names: {
					contentDescription: "contentDescription",
					contentType: "contentType"
				}
			}));

			if (asn1.verified === false) throw new Error("Object's schema was not verified against input data for ContentHints");
			//endregion

			//region Get internal properties from parsed schema
			if ("contentDescription" in asn1.result) this.contentDescription = asn1.result.contentDescription.valueBlock.value;

			// noinspection JSUnusedGlobalSymbols
			this.contentType = asn1.result.contentType.valueBlock.toString();
			//endregion
		}
		//**********************************************************************************
		/**
   * Convert current object to asn1js object and set correct values
   * @returns {Object} asn1js object
   */

	}, {
		key: "toSchema",
		value: function toSchema() {
			//region Construct and return new ASN.1 schema for this object
			return new asn1js.Sequence({
				value: [new asn1js.Utf8String({ value: this.contentType }), new asn1js.ObjectIdentifier({ value: this.contentType })]
			});
			//endregion
		}
		//**********************************************************************************
		/**
   * Convertion for the class to JSON object
   * @returns {Object}
   */

	}, {
		key: "toJSON",
		value: function toJSON() {
			return {
				contentDescription: this.contentDescription,
				contentType: this.contentType
			};
		}
		//**********************************************************************************

	}], [{
		key: "defaultValues",
		value: function defaultValues(memberName) {
			switch (memberName) {
				case "contentDescription":
				case "contentType":
					return "";
				default:
					throw new Error("Invalid member name for ContentHints class: " + memberName);
			}
		}
		//**********************************************************************************
		/**
   * Compare values with default values for all class members
   * @param {string} memberName String name for a class member
   * @param {*} memberValue Value to compare with default value
   */

	}, {
		key: "compareWithDefault",
		value: function compareWithDefault(memberName, memberValue) {
			switch (memberName) {
				case "contentDescription":
				case "contentType":
					return memberValue === "";
				default:
					throw new Error("Invalid member name for ContentHints class: " + memberName);
			}
		}
		//**********************************************************************************
		/**
   * Return value of asn1js schema for current class
   * @param {Object} parameters Input parameters for the schema
   * @returns {Object} asn1js schema object
   */

	}, {
		key: "schema",
		value: function schema() {
			var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			// ContentHints ::= SEQUENCE {
			//    contentDescription UTF8String (SIZE (1..MAX)) OPTIONAL,
			//    contentType ContentType }

			/**
    * @type {Object}
    * @property {string} [blockName]
    * @property {string} [contentDescription]
    * @property {string} [contentType]
    */
			var names = (0, _pvutils.getParametersValue)(parameters, "names", {});

			return new asn1js.Sequence({
				name: names.blockName || "",
				value: [new asn1js.Utf8String({
					name: names.contentDescription || "",
					optinal: true
				}), new asn1js.ObjectIdentifier({ name: names.contentType || "" })]
			});
		}
	}]);

	return ContentHints;
}();
//**************************************************************************************


exports.default = ContentHints;
//# sourceMappingURL=ContentHints.js.map