"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _asn1js = require("asn1js");

var asn1js = _interopRequireWildcard(_asn1js);

var _pvutils = require("pvutils");

var _pkijs = require("pkijs");

var _OtherCertID = require("./OtherCertID.js");

var _OtherCertID2 = _interopRequireDefault(_OtherCertID);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

//**************************************************************************************
// noinspection JSUnusedGlobalSymbols
var OtherSigningCertificate = function () {
	//**********************************************************************************
	/**
  * Constructor for OtherSigningCertificate class
  * @param {Object} [parameters={}]
  * @property {Object} [schema] asn1js parsed value
  */
	function OtherSigningCertificate() {
		var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		_classCallCheck(this, OtherSigningCertificate);

		//region Internal properties of the object
		/**
   * @type {Array.<OtherCertID>}
   * @description certs
   */
		this.certs = (0, _pvutils.getParametersValue)(parameters, "certs", OtherSigningCertificate.defaultValues("certs"));

		if ("policies" in parameters)
			/**
    * @type {Array.<PolicyInformation>}
    * @description policies
    */
			this.policies = (0, _pvutils.getParametersValue)(parameters, "policies", OtherSigningCertificate.defaultValues("policies"));
		//endregion

		//region If input argument array contains "schema" for this object
		if ("schema" in parameters) this.fromSchema(parameters.schema);
		//endregion
	}
	//**********************************************************************************
	/**
  * Return default values for all class members
  * @param {string} memberName String name for a class member
  */


	_createClass(OtherSigningCertificate, [{
		key: "fromSchema",

		//**********************************************************************************
		/**
   * Convert parsed asn1js object into current class
   * @param {!Object} schema
   */
		value: function fromSchema(schema) {
			//region Check the schema is valid
			var asn1 = asn1js.compareSchema(schema, schema, OtherSigningCertificate.schema({
				names: {
					certs: "certs",
					policies: "policies"
				}
			}));

			if (asn1.verified === false) throw new Error("Object's schema was not verified against input data for OtherSigningCertificate");
			//endregion

			//region Get internal properties from parsed schema
			//region certs
			// noinspection JSUnusedGlobalSymbols
			this.certs = Array.from(asn1.result.certs, function (element) {
				return new _OtherCertID2.default({ schema: element });
			});
			//endregion

			//region policies
			if ("policies" in asn1.result) this.policies = Array.from(asn1.result.policies, function (element) {
				return new _pkijs.PolicyInformation({ schema: element });
			});
			//endregion
			//endregion
		}
		//**********************************************************************************
		/**
   * Convert current object to asn1js object and set correct values
   * @returns {Object} asn1js object
   */

	}, {
		key: "toSchema",
		value: function toSchema() {
			//region Create array for output sequence
			var outputArray = [new asn1js.Sequence({
				value: Array.from(this.certs, function (element) {
					return element.toSchema();
				})
			})];

			//region policies
			if ("policies" in this) {
				outputArray.push(new asn1js.Sequence({
					value: Array.from(this.policies, function (element) {
						return element.toSchema();
					})
				}));
			}
			//endregion
			//endregion

			//region Construct and return new ASN.1 schema for this object
			return new asn1js.Sequence({
				value: outputArray
			});
			//endregion
		}
		//**********************************************************************************
		/**
   * Convertion for the class to JSON object
   * @returns {Object}
   */

	}, {
		key: "toJSON",
		value: function toJSON() {
			var _object = {
				certs: Array.from(this.certs, function (element) {
					return element.toJSON();
				})
			};

			//region policies
			if ("policies" in this) _object.policies = Array.from(this.policies, function (element) {
				return element.toJSON();
			});
			//endregion

			return _object;
		}
		//**********************************************************************************

	}], [{
		key: "defaultValues",
		value: function defaultValues(memberName) {
			switch (memberName) {
				case "certs":
				case "policies":
					return [];
				default:
					throw new Error("Invalid member name for OtherSigningCertificate class: " + memberName);
			}
		}
		//**********************************************************************************
		/**
   * Compare values with default values for all class members
   * @param {string} memberName String name for a class member
   * @param {*} memberValue Value to compare with default value
   */

	}, {
		key: "compareWithDefault",
		value: function compareWithDefault(memberName, memberValue) {
			switch (memberName) {
				case "certs":
				case "policies":
					return memberValue.length === 0;
				default:
					throw new Error("Invalid member name for OtherSigningCertificate class: " + memberName);
			}
		}
		//**********************************************************************************
		/**
   * Return value of asn1js schema for current class
   * @param {Object} parameters Input parameters for the schema
   * @returns {Object} asn1js schema object
   */

	}, {
		key: "schema",
		value: function schema() {
			var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			// OtherSigningCertificate ::= SEQUENCE {
			//    certs SEQUENCE OF OtherCertID,
			//    policies SEQUENCE OF PolicyInformation OPTIONAL
			//    -- NOT USED IN THE PRESENT DOCUMENT }

			/**
    * @type {Object}
    * @property {string} [blockName]
    * @property {string} [type]
    * @property {string} [setName]
    * @property {string} [values]
    */
			var names = (0, _pvutils.getParametersValue)(parameters, "names", {});

			return new asn1js.Sequence({
				name: names.blockName || "",
				value: [new asn1js.Sequence({
					value: [new asn1js.Repeated({
						name: names.certs || "",
						value: _OtherCertID2.default.schema()
					})]
				}), new asn1js.Sequence({
					value: [new asn1js.Repeated({
						name: names.policies || "",
						value: _pkijs.PolicyInformation.schema()
					})]
				})]
			});
		}
	}]);

	return OtherSigningCertificate;
}();
//**************************************************************************************


exports.default = OtherSigningCertificate;
//# sourceMappingURL=OtherSigningCertificate.js.map